<div class="w2dc-content">
	<?php w2dc_renderMessages(); ?>

	<?php if (w2dc_can_user_add_review($listing->post->ID)): ?>
	<h3><?php echo sprintf(__('Add Review to "%s"', 'W2DC'), $listing->title()); ?></h3>

	<form action="<?php echo w2dc_get_add_review_link($listing->post->ID); ?>" method="POST" enctype="multipart/form-data">
		<input type="hidden" name="review_id" value="<?php echo $review->post->ID; ?>" />
		<input type="hidden" name="review_id_hash" value="<?php echo md5($review->post->ID . wp_salt()); ?>" />
		<?php wp_nonce_field('w2dc_submit', '_submit_nonce'); ?>

		<?php if (!is_user_logged_in() && get_option('w2dc_reviews_allowed_users') == 'guests'): ?>
		<div class="w2dc-submit-section w2dc-submit-section-contact-info">
			<h3 class="w2dc-submit-section-label"><?php _e('User info', 'W2DC'); ?></h3>
			<div class="w2dc-submit-section-inside">
				<label class="w2dc-fsubmit-contact"><?php _e('Your Name', 'W2DC'); ?></label>
				<input type="text" name="w2dc_user_contact_name" value="<?php echo esc_attr($frontend_controller->w2dc_user_contact_name); ?>" class="w2dc-form-control" style="width: 100%;" />

				<label class="w2dc-fsubmit-contact"><?php _e('Your Email', 'W2DC'); ?></label>
				<input type="text" name="w2dc_user_contact_email" value="<?php echo esc_attr($frontend_controller->w2dc_user_contact_email); ?>" class="w2dc-form-control" style="width: 100%;" />
				<p class="w2dc-description"><?php _e("Login information will be sent to your email after submission", "W2DC"); ?></p>
			</div>
		</div>
		<?php endif; ?>

		<div class="w2dc-submit-section w2dc-submit-section-title">
			<h3 class="w2dc-submit-section-label"><?php _e('Review title', 'W2DC'); ?><span class="w2dc-red-asterisk">*</span></h3>
			<div class="w2dc-submit-section-inside">
				<input type="text" name="post_title" style="width: 100%" class="w2dc-form-control" value="<?php if ($review->post->post_title != __('Auto Draft', 'W2DC')) echo esc_attr($review->post->post_title); ?>" />
			</div>
		</div>
		
		<div class="w2dc-submit-section w2dc-submit-section-rating">
			<?php if (!$w2dc_instance->reviews_manager->getRatingsCriterias()): ?>
			<h3 class="w2dc-submit-section-label"><?php _e('Review rating', 'W2DC'); ?><span class="w2dc-red-asterisk">*</span></h3>
			<div class="w2dc-submit-section-inside">
				<?php w2dc_renderTemplate(array(W2DC_RATINGS_TEMPLATES_PATH, 'avg_rating.tpl.php'), array('avg_rating' => $review->avg_rating, 'post_id' => $review->post->ID, 'noajax' => true, 'meta_tags' => false, 'active' => true, 'show_avg' => false)); ?>
			</div>
			<?php else: ?>
			<h3 class="w2dc-submit-section-label"><?php _e('Review ratings', 'W2DC'); ?></h3>
			<div class="w2dc-submit-section-inside">
				<?php $w2dc_instance->reviews_manager->ratingsCriteriasMetabox($review->post); ?>
			</div>
			<?php endif; ?>
		</div>

		<div class="w2dc-submit-section w2dc-submit-section-description">
			<h3 class="w2dc-submit-section-label"><?php _e('Description', 'W2DC'); ?><span class="w2dc-red-asterisk">*</span></h3>
			<div class="w2dc-submit-section-inside">
				<?php wp_editor($review->post->post_content, 'post_content', array('media_buttons' => false, 'editor_class' => 'w2dc-editor-class')); ?>
			</div>
		</div>
	
		<?php if (get_option("w2dc_reviews_images_number") > 0): ?>
		<div class="w2dc-submit-section w2dc-submit-section-media">
			<h3 class="w2dc-submit-section-label"><?php _e('Review Media', 'W2DC'); ?></h3>
			<div class="w2dc-submit-section-inside">
				<?php $w2dc_instance->media_manager->mediaMetabox($review->post, array('args' => array('target' => 'reviews'))); ?>
			</div>
		</div>
		<?php endif; ?>
		
		<?php do_action('w2dc_create_review_metaboxes_post', $review); ?>

		<?php if (get_option('w2dc_enable_recaptcha')): ?>
		<div class="w2dc-submit-section-adv">
			<?php echo w2dc_recaptcha(); ?>
		</div>
		<?php endif; ?>

		<?php
		if ($tos_page = w2dc_get_wpml_dependent_option('w2dc_tospage')) : ?>
		<div class="w2dc-submit-section-adv">
			<label><input type="checkbox" name="w2dc_tospage" value="1" /> <?php printf(__('I agree to the ', 'W2DC') . '<a href="%s" target="_blank">%s</a>', get_permalink($tos_page), __('Terms of Services', 'W2DC')); ?></label>
		</div>
		<?php endif; ?>

		<?php require_once(ABSPATH . 'wp-admin/includes/template.php'); ?>
		<?php submit_button(__('Submit review', 'W2DC'), 'w2dc-btn w2dc-btn-primary')?>
	</form>
	<?php endif; ?>
</div>