		<div class="w2dc-content w2dc-review-single">
			<?php w2dc_renderMessages(); ?>

			<?php while ($reviews_controller->query->have_posts()): ?>
				<?php $reviews_controller->query->the_post(); ?>
				<?php $review = $reviews_controller->reviews[get_the_ID()]; ?>
				<div id="<?php echo $review->post->post_name; ?>" itemscope itemtype="http://schema.org/Review">
					<?php if (w2dc_show_edit_review_button($review->post->ID)): ?>
					<div class="w2dc-content w2dc-directory-frontpanel">
						<a class="w2dc-edit-review-link w2dc-btn w2dc-btn-primary" href="<?php echo w2dc_get_edit_review_link($review->post->ID); ?>" rel="nofollow" data-toggle="w2dc-tooltip" data-placement="top" data-original-title="<?php _e('Edit review', 'W2DC'); ?>"><span class="w2dc-glyphicon w2dc-glyphicon-pencil"></span></a>
					</div>
					<?php endif; ?>
				
					<?php if ($review->title()): ?>
					<header class="w2dc-review-header">
						<h2 itemprop="name"><?php echo $frontend_controller->getPageTitle(); ?> <?php $review->renderStars(); ?></h2>
						<?php if (!get_option('w2dc_hide_views_counter')): ?>
						<div class="w2dc-meta-data">
							<div class="w2dc-views-counter">
								<span class="w2dc-glyphicon w2dc-glyphicon-eye-open"></span> <?php _e('views', 'W2DC')?>: <?php echo get_post_meta($review->post->ID, '_total_clicks', true); ?>
							</div>
						</div>
						<?php endif; ?>
						<?php if (!get_option('w2dc_hide_listings_creation_date')): ?>
						<div class="w2dc-meta-data">
							<div class="w2dc-listing-date" datetime="<?php echo date("Y-m-d", mysql2date('U', $review->post->post_date)); ?>T<?php echo date("H:i", mysql2date('U', $review->post->post_date)); ?>"><?php echo get_the_date(); ?> <?php echo get_the_time(); ?></div>
						</div>
						<?php endif; ?>
						<?php if (!get_option('w2dc_hide_author_link')): ?>
						<div class="w2dc-meta-data">
							<div class="w2dc-author-link">
								<?php _e('By', 'W2DC'); ?> <?php echo get_the_author_link(); ?>
							</div>
						</div>
						<?php endif; ?>
						<?php if (get_option('w2dc_share_buttons') && get_option('w2dc_share_buttons_place') == 'title'): ?>
						<?php w2dc_renderTemplate('frontend/sharing_buttons_ajax_call.tpl.php', array('post_id' => $review->post->ID, 'post_url' => get_permalink($review->post->ID))); ?>
						<?php endif; ?>
						<?php if ($frontend_controller->breadcrumbs): ?>
						<ol class="w2dc-breadcrumbs" itemscope itemtype="http://schema.org/BreadcrumbList">
							<?php echo $frontend_controller->getBreadCrumbs(); ?>
						</ol>
						<?php endif; ?>
					</header>
					<?php endif; ?>

					<article id="post-<?php echo $review->post->ID; ?>" class="w2dc-review">
						<?php if ($review->images): ?>
						<div class="w2dc-review-logo-wrap w2dc-single-review-logo-wrap" id="images">
							<?php do_action('w2dc_review_pre_logo_wrap_html', $review); ?>

							<?php
							$images = array();
							foreach ($review->images AS $attachment_id=>$image) {
								$image_src = wp_get_attachment_image_src($attachment_id, 'full');
								$image_title = $image['post_title'];
								if (get_option('w2dc_enable_lighbox_gallery')) {
									$images[] = '<a href="' . $image_src[0] . '" data-w2dc-lightbox="listing_images" title="' . esc_attr($image_title) . '"><img src="' . $image_src[0] . '" alt="' . esc_attr($image_title) . '" title="' . esc_attr($image_title) . '" /></a>';
								} else {
									$images[] = '<img src="' . $image_src[0] . '" alt="' . esc_attr($image_title) . '" title="' . esc_attr($image_title) . '" />';
								}
							}
							$max_slides = (count($review->images) < 5) ? count($review->images) : 5;
							if (get_option('w2dc_100_single_logo_width'))
								w2dc_renderTemplate('frontend/slider.tpl.php', array(
										'slide_width' => 150,
										'max_width' => false,
										'max_slides' => $max_slides,
										'height' => 450,
										'images' => $images,
										'crop' => (get_option('w2dc_big_slide_bg_mode') == 'contain') ? 0 : 1,
										'enable_links' => get_option('w2dc_enable_lighbox_gallery'),
										'auto_slides' => get_option('w2dc_auto_slides_gallery'),
										'auto_slides_delay' => get_option('w2dc_auto_slides_gallery_delay'),
										'random_id' => w2dc_generateRandomVal()
								));
							else
								w2dc_renderTemplate('frontend/slider.tpl.php', array(
										'slide_width' => 130,
										'max_width' => get_option('w2dc_single_logo_width'),
										'max_slides' => $max_slides,
										'height' => get_option('w2dc_single_logo_width')*0.7,
										'images' => $images,
										'crop' => (get_option('w2dc_big_slide_bg_mode') == 'contain') ? 0 : 1,
										'enable_links' => get_option('w2dc_enable_lighbox_gallery'),
										'auto_slides' => get_option('w2dc_auto_slides_gallery'),
										'auto_slides_delay' => get_option('w2dc_auto_slides_gallery_delay'),
										'random_id' => w2dc_generateRandomVal()
								));

							// Special trick for lightbox
							if ($images && get_option('w2dc_enable_lighbox_gallery')): ?>
							<div id="w2dc-lighbox-images" style="display: none;"><?php foreach ($images AS $image) echo $image; ?></div>
							<?php endif; ?>
						</div>
						<?php endif; ?>

						<div class="w2dc-single-review-text-content-wrap">
							<?php if (get_option('w2dc_share_buttons') && get_option('w2dc_share_buttons_place') == 'before_content'): ?>
							<?php w2dc_renderTemplate('frontend/sharing_buttons_ajax_call.tpl.php', array('post_id' => $review->post->ID, 'post_url' => get_permalink($review->post->ID))); ?>
							<?php endif; ?>
						
							<?php do_action('w2dc_review_pre_content_html', $review); ?>
					
							<span itemprop="reviewBody">
							<?php add_filter('the_content', 'wpautop'); ?>
							<?php the_content(); ?>
							<?php remove_filter('the_content', 'wpautop'); ?>
							</span>

							<?php do_action('w2dc_review_post_content_html', $review); ?>
							
							<?php if (get_option('w2dc_share_buttons') && get_option('w2dc_share_buttons_place') == 'after_content'): ?>
							<?php w2dc_renderTemplate('frontend/sharing_buttons_ajax_call.tpl.php', array('post_id' => $review->post->ID, 'post_url' => get_permalink($review->post->ID))); ?>
							<?php endif; ?>
						</div>

						<?php if ($ratings_criterias = $w2dc_instance->reviews_manager->getRatingsCriterias()): ?>
						<?php w2dc_renderTemplate(array(W2DC_RATINGS_TEMPLATES_PATH, 'ratings_criterias_overall.tpl.php'), array('ratings_criterias' => $ratings_criterias, 'values' => $review->ratings)); ?>
						<?php endif; ?>
						
						<div class="w2dc-single-review-comments-votes w2dc-row">
							<div class="w2dc-single-review-comments-label w2dc-col-md-6">
								<?php echo $review->post->comment_count; ?> <?php echo _n('Comment', 'Comments', $review->post->comment_count, 'W2DC'); ?>
							</div>
							<?php if (get_option("w2dc_reviews_votes")): ?>
							<div class="w2dc-single-review-votes w2dc-col-md-6 w2dc-pull-right">
								<?php w2dc_renderTemplate(array(W2DC_RATINGS_TEMPLATES_PATH, 'review_votes.tpl.php'), array('review' => $review)); ?>
							</div>
							<?php endif; ?>
						</div>
						
						<div class="w2dc-single-review-comments">
							<?php w2dc_renderTemplate(array(W2DC_RATINGS_TEMPLATES_PATH, 'comments.tpl.php'), array('post' => $review->post)); ?>
						</div>
					</article>
				</div>
			<?php endwhile; ?>
		</div>